<?php
class FRANCHISE{
	public $table_config;
	public $table_list;
	public $table_category;

	public $pageid;
	public $listtitle;
	public $listcomment;
	public $usemapnavi;
	public $template;
	public $category;
	public $perpage;
	public $useapi;
	public $naverapiid;
	public $naverapisecret;
	public $daumapikey;

  //초기화
  public function __construct() {
		global $wpdb;

		$this->check_tables();

		$this->table_config = 'bbse_franchise_config';
		$this->table_list   = 'bbse_franchise';

		$configs = $wpdb->get_row( "SELECT * FROM {$this->table_config} WHERE prefix='{$wpdb->prefix}'" );
		if ($configs) {
			$this->pageid         = $configs->pageid;
			$this->listtitle      = $configs->listtitle;
			$this->listcomment    = $configs->listcomment;
			$this->usemapnavi     = $configs->usemapnavi;
			$this->template       = $configs->template;
			$this->category       = $configs->category;
			$this->perpage        = $configs->perpage;
			$this->useapi         = $configs->useapi;
			$this->naverapiid     = $configs->naverapiid;
			$this->naverapisecret = $configs->naverapisecret;
			$this->daumapikey     = $configs->daumapikey;
		}

		if (is_admin()) {
			add_filter( 'wp_default_editor', create_function('', 'return "tinymce";') );
		}
	}

	// 활성화
	public function activation() {
		$this->check_tables();
	}

	// 테이블 확인/생성
	public function check_tables() {
		global $wpdb;

		$installed_version = get_option('franchise_db_version');
		$table_config      = $wpdb->get_var(" SHOW TABLES LIKE '{$this->table_config}' ");
		$table_list        = $wpdb->get_var(" SHOW TABLES LIKE '{$this->table_list}' ");

		if (!$installed_version || ($installed_version && $installed_version < BBSE_FRANCHISE_DB_VER) || empty($table_config[0]) || empty($table_list[0])){
			$this->_dbdelta_bbse_franchise();

			if (!$installed_version){
				add_option( 'franchise_db_version', BBSE_FRANCHISE_DB_VER, '', 'no' );
			} else if ($installed_version && $installed_version < BBSE_FRANCHISE_DB_VER){
				update_option( 'franchise_db_version', BBSE_FRANCHISE_DB_VER, 'no' );
			}
		}
	}

	// 테이블 생성
	protected function _dbdelta_bbse_franchise() {
		global $wpdb;
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

		$charset = $wpdb->get_charset_collate();

		//create config table
		$query = '';
		$query = " CREATE TABLE `{$this->table_config}` (
								`uid` int(11) NOT NULL AUTO_INCREMENT COMMENT '고유번호',
								`prefix` varchar(255) NOT NULL COMMENT '사이트구분',
								`pageid` int(11) NOT NULL COMMENT '삽입페이지 번호',
								`listtitle` varchar(255) NOT NULL COMMENT '목록 제목',
								`listcomment` varchar(255) NOT NULL COMMENT '목록 코멘트',
								`usemapnavi` enum('y','n') NOT NULL DEFAULT 'y' COMMENT '지도네비 사용여부',
								`template` varchar(255) NOT NULL COMMENT '사용스킨',
								`category` text NOT NULL COMMENT '카테고리',
								`perpage` tinyint(4) NOT NULL COMMENT '페이지당 목록수',
								`useapi` varchar(10) NOT NULL COMMENT 'api종류',
								`naverapiid` varchar(255) NOT NULL COMMENT '네이버아이디',
								`naverapisecret` varchar(255) NOT NULL COMMENT '네이버시큐리티',
								`daumapikey` varchar(255) NOT NULL COMMENT '다음지도',
								`var1` text NOT NULL COMMENT '예비1',
								`var2` text NOT NULL COMMENT '예비2',
								`var3` text NOT NULL COMMENT '예비3',
								`var4` text NOT NULL COMMENT '예비4',
								`var5` text NOT NULL COMMENT '예비5',
								`var6` text NOT NULL COMMENT '예비6',
								`var7` text NOT NULL COMMENT '예비7',
								`var8` text NOT NULL COMMENT '예비8',
								`var9` text NOT NULL COMMENT '예비9',
								`var10` text NOT NULL COMMENT '예비10',
								PRIMARY KEY (`uid`),
								KEY `prefix` (`prefix`(250))
							) {$charset}; ";
		dbDelta( $query );

		//create list table
		$query = '';
		$query = " CREATE TABLE `{$this->table_list}` (
								`uid` int(11) NOT NULL AUTO_INCREMENT COMMENT '키',
								`prefix` varchar(255) NOT NULL COMMENT '사이트구분',
								`hide` enum('Y','N') NOT NULL DEFAULT 'N' COMMENT '보임',
								`category` varchar(255) NOT NULL COMMENT '카테고리번호',
								`branchname` varchar(255) NOT NULL COMMENT '지점이름',
								`addresstype` enum('J','R') NOT NULL DEFAULT 'J' COMMENT '주소종류(지번,도로)',
								`languagetype` enum('K','E') NOT NULL DEFAULT 'K' COMMENT '표시 주소언어',
								`zipcode` varchar(8) NOT NULL COMMENT '우편번호',
								`address1` varchar(255) NOT NULL COMMENT '주소1',
								`address2` varchar(255) NOT NULL COMMENT '주소2',
								`mapaddress` varchar(255) NOT NULL COMMENT '지도용 주소',
								`conutry` varchar(30) NOT NULL COMMENT '나라',
								`sido` varchar(30) NOT NULL COMMENT '도시',
								`sigungu` varchar(255) NOT NULL COMMENT '시군구',
								`bname` varchar(30) NOT NULL COMMENT '지역',
								`phone` varchar(30) NOT NULL COMMENT '전화번호',
								`mobile` varchar(30) NOT NULL COMMENT '모바일번호',
								`fax` varchar(30) NOT NULL COMMENT '팩스번호',
								`email` varchar(255) NOT NULL COMMENT '이메일주소',
								`tag` varchar(255) NOT NULL,
								`memo` text NOT NULL COMMENT '내용',
								`regdate` varchar(10) NOT NULL COMMENT '등록일',
								`var1` text NOT NULL COMMENT '예비1',
								`var2` text NOT NULL COMMENT '예비2',
								`var3` text NOT NULL COMMENT '예비3',
								`var4` text NOT NULL COMMENT '예비4',
								`var5` text NOT NULL COMMENT '예비5',
								`var6` text NOT NULL COMMENT '예비6',
								`var7` text NOT NULL COMMENT '예비7',
								`var8` text NOT NULL COMMENT '예비8',
								`var9` text NOT NULL COMMENT '예비9',
								`var10` text NOT NULL COMMENT '예비10',
								PRIMARY KEY (`uid`),
								KEY `prefix` (`prefix`(250)),
								KEY `hide` (`hide`),
								KEY `category` (`category`(250)),
								KEY `branchname` (`branchname`(250)),
								KEY `address1` (`address1`(250)),
								KEY `address2` (`address2`(250)),
								KEY `sido` (`sido`),
								KEY `sigungu` (`sigungu`(250)),
								KEY `bname` (`bname`),
								KEY `phone` (`phone`),
								KEY `mobile` (`mobile`),
								KEY `fax` (`fax`),
								KEY `email` (`email`(250)),
								KEY `tag` (`tag`(250))
					  	) {$charset}; ";
		dbDelta( $query );
	}

	//테이블 삭제
	protected function _delete_tables() {
		global $wpdb;
		if ( $wpdb->query("DROP TABLE `bbse_franchise`, `bbse_franchise_config`;") ){
			return 'deleted';
		} else {
			return 'fail';
		}
	}

	// 비활성화
	public function deactivation() {
		//BLANK
	}

	//관리자 메뉴추가
	public function add_admin_menu() {
		add_menu_page('BBS e-Franchise', 'BBS e-Franchise', 'administrator', 'bbse_franchise', array($this, 'branches_lists_page'));
		add_submenu_page('bbse_franchise', '지점목록', '지점목록', 'administrator', 'bbse_franchise', array($this, 'branches_lists_page'));
		add_submenu_page('bbse_franchise', '지점추가', '지점추가', 'administrator', 'manage_braches_page', array($this, 'manage_braches_page'));
		add_submenu_page('bbse_franchise', '환경설정', '환경설정', 'administrator', 'manage_plugin_page', array($this, 'manage_plugin_page'));
		add_submenu_page('bbse_franchise', '데이터 관리', '데이터 관리', 'administrator', 'manage_plugin_data_page', array($this, 'manage_plugin_data_page'));
	}

	//지점 목록 페이지
	public function branches_lists_page() {
		require_once(BBSE_FRANCHISE_PLUGIN_ABS_PATH."admin/franchise_list.php");
	}
	//지점 추가 페이지
	public function manage_braches_page() {
		wp_enqueue_script('jquery');
		wp_enqueue_script('jquery-form');
		wp_register_script('daum-postcode-api', 'http://dmaps.daum.net/map_js_init/postcode.v2.js', false, '2');
		wp_enqueue_script('daum-postcode-api');

		require_once(BBSE_FRANCHISE_PLUGIN_ABS_PATH."admin/franchise_manage_branches.php");
	}
	//플러그인 관리 페이지
	public function manage_plugin_page() {
		wp_enqueue_script('jquery');
		wp_enqueue_script('jquery-form');
		wp_enqueue_script('jquery-color');

		require_once(BBSE_FRANCHISE_PLUGIN_ABS_PATH."admin/franchise_manage_plugin.php");
	}

	//플러그인 데이터 관리 페이지
	public function manage_plugin_data_page() {
		wp_enqueue_script('jquery');
		wp_enqueue_script('jquery-form');
		wp_enqueue_script('jquery-color');

		require_once(BBSE_FRANCHISE_PLUGIN_ABS_PATH."admin/franchise_manage_plugin_data.php");
	}

	/***************************************************/
	/*
			ADMINISTRATION LEVEL
	*/
	/***************************************************/
	// Save/Make config data
	public function config_save() {
		global $wpdb;

		$firstConfig = false;
		$myConfigs   = $wpdb->get_row( "SELECT * FROM {$this->table_config} WHERE prefix='{$wpdb->prefix}'" );
		if ( $myConfigs->prefix != $wpdb->prefix  ) {
			$firstConfig = true;
		}

		$usemapnavi      = $myConfigs->usemapnavi;
		$template        = $myConfigs->template;
		$category        = $myConfigs->category;
		$perpage         = $myConfigs->perpage;
		$useapi          = $myConfigs->useapi;
		$naverapiid      = $myConfigs->naverapiid;
		$naverapisecret  = $myConfigs->naverapisecret;
		$daumapikey      = $myConfigs->daumapikey;

		if ( isset($_POST['pageid']) && !empty($_POST['pageid']) ) {
			$pageid = $_POST['pageid'];
		} else {
			$pageid = '';
		}

		if ( isset($_POST['listtitle']) && !empty($_POST['listtitle']) ) {
			$listtitle = $_POST['listtitle'];
		} else {
			$listtitle = '';
		}

		if ( isset($_POST['listcomment']) && !empty($_POST['listcomment']) ) {
			$listcomment = $_POST['listcomment'];
		} else {
			$listcomment = '';
		}

		if ( isset($_POST['usemapnavi']) && !empty($_POST['usemapnavi']) ) {
			$usemapnavi = $_POST['usemapnavi'];
		} else {
			$usemapnavi = 'n';
		}

		//사용스킨 설정
		if ( isset($_POST['template']) && !empty($_POST['template']) ) {
			$template = $_POST['template'];
		} else {
			echo 'empty^template'; exit;
		}

		//카테고리설정
		if ( isset($_POST['category']) && !empty($_POST['category']) ) {
			$catTempArr = explode(',',$_POST['category']);
			foreach($catTempArr as $k => $v) {
				$catTempArr[$k] = trim($v);
			}
			$category = implode(',', array_unique($catTempArr));
		} else {
			//echo 'empty^category'; exit;
			$category = '';
		}

		//페이당 등록수
		if ( isset($_POST['perpage']) && !empty($_POST['perpage']) ) {
			$perpage = $_POST['perpage'];
		} else {
			$perpage = get_option('posts_per_page');
		}

		if ( isset($_POST['useapi']) && !empty($_POST['useapi']) ) {
			$useapi = $_POST['useapi'];
		} else {
			$useapi = 'none';
		}

		if ( $useapi != 'none') {
			//apikey
			if ( $useapi == 'naver' ) {
				if (!$_POST['naverapiid']) {
					echo 'empty^naverapiid'; exit;
				} else {
					$naverapiid = trim($_POST['naverapiid']);
				}

				if (!$_POST['naverapisecret']) {
					echo 'empty^naverapisecret'; exit;
				} else {
					$naverapisecret = trim($_POST['naverapisecret']);
				}
			}

			if ( $useapi == 'daum' && !$_POST['daumapikey'] ) {
				echo 'empty^daumapikey'; exit;
			} else {
				$daumapikey = trim($_POST['daumapikey']);
			}
		}

		$naverapiid     = $naverapiid     ? $naverapiid     : '';
		$naverapisecret = $naverapisecret ? $naverapisecret : '';
		$daumapikey     = $daumapikey     ? $daumapikey     : '';

		//데이터 준비
		$dataSet = array(
			'pageid'         => $pageid,
			'listtitle'      => sanitize_text_field($listtitle),
			'listcomment'    => sanitize_text_field($listcomment),
			'usemapnavi'     => $usemapnavi,
			'template'       => $template,
			'category'       => sanitize_text_field($category),
			'perpage'        => $perpage,
			'useapi'         => $useapi,
			'naverapiid'     => sanitize_text_field($naverapiid),
			'naverapisecret' => sanitize_text_field($naverapisecret),
			'daumapikey'     => sanitize_text_field($daumapikey),
		);

		// 일반 저장이면
		if ($firstConfig == false) {
			$wpdb->update(
				$this->table_config,
				$dataSet,
				array('prefix' => $wpdb->prefix)
			);
		// 첫 저장이면
		} elseif ($firstConfig == true) {
			$dataSet['prefix'] = $wpdb->prefix;
			$wpdb->insert(
				$this->table_config,
				$dataSet,
				array( "%d", "%s", "%s", "%s", "%s", "%s", "%d", "%s", "%s", "%s", "%s", "%s" )
			);
		}
	}

	// manage branches
	public function branch_save() {
		global $wpdb;

		$myBranch  = $wpdb->get_row( "SELECT * FROM {$this->table_list} WHERE prefix='{$wpdb->prefix}'" );

		//keep prev. data
		$hide         = $myBranch->hide;
		$category     = $myBranch->category;
		$branchname   = $myBranch->branchname;
		$addresstype  = $myBranch->addresstype;
		$languagetype = $myBranch->languagetype;
		$zipcode      = $myBranch->zipcode;
		$address1     = $myBranch->address1;
		$address2     = $myBranch->address2;
		$mapaddress   = $myBranch->mapaddress;
		$sido         = $myBranch->sido;
		$sigungu      = $myBranch->sigungu;
		$bname        = $myBranch->bname;
		$phone        = $myBranch->phone;
		$mobile       = $myBranch->mobile;
		$fax          = $myBranch->fax;
		$email        = $myBranch->email;
		$tag          = $myBranch->tag;
		$memo         = $myBranch->memo;

		//노출 설정
		if ( isset($_POST['hide']) && !empty($_POST['hide']) && $_POST['hide'] == 'Y') {
			$hide = 'Y';
		} else {
			$hide = 'N';
		}

		//카테고리설정
		if ( isset($_POST['category']) && !empty($_POST['category']) ) {
			$category = $_POST['category'];
		} else {
			//echo 'empty^category'; exit;
			$category = '';
		}

		//지점이름
		if ( isset($_POST['branchname']) && !empty($_POST['branchname']) ) {
			$branchname = $_POST['branchname'];
		} else {
			echo 'empty^branchname'; exit;
		}

		//주소
		if ( empty($_POST['address1']) ) {
			echo 'empty^address1'; exit;
		}	else {
			$address1 = $_POST['address1'];
		}

		if ( empty($_POST['address2']) ) {
			echo 'empty^address2'; exit;
		} else {
			$address2 = $_POST['address2'];
		}

		if ( $address1 && $address2 )	{
			if ( isset($_POST['addresstype'])  && !empty($_POST['addresstype']) )  $addresstype  = $_POST['addresstype'];
			if ( isset($_POST['languagetype']) && !empty($_POST['languagetype']) ) $languagetype = $_POST['languagetype'];
			if ( isset($_POST['zipcode'])      && !empty($_POST['zipcode']) )      $zipcode      = $_POST['zipcode'];
			if ( isset($_POST['sido'])         && !empty($_POST['sido']) )         $sido         = $_POST['sido'];
			if ( isset($_POST['sigungu'])      && !empty($_POST['sigungu']) )      $sigungu      = $_POST['sigungu'];
			if ( isset($_POST['bname'])        && !empty($_POST['bname']) )        $bname        = $_POST['bname'];
		} else {
			echo 'empty^address1'; exit;
		}
		if ($languagetype == 'K') {
			if ( empty($_POST['mapaddress']) ) {
				$mapaddress = $address1;
			} else {
				$mapaddress = $_POST['mapaddress'];
			}
		} else {
			if ( empty($_POST['mapaddress']) ) {
				echo 'empty^address1'; exit;
			} else {
				$mapaddress = $_POST['mapaddress'];
			}
		}

		//전화번호
		if ( isset($_POST['phone']) && !empty($_POST['phone']) ) {
			$phone  = str_replace(array(' ', '-', ' /', '.'), '', trim($_POST['phone']));
			$parsed = $this->parsePhoneNumber($phone, 'P');
			if ($parsed == false) {
				echo 'error^phone'; exit;
			}
			$phone = implode('-', $parsed);
			if ($phone === false) {
				echo 'error^phone'; exit;
			}
		} else {
			//echo 'empty^phone'; exit;
			$phone = '';
		}

		//휴대전화번호
		if ( isset($_POST['mobile']) && !empty($_POST['mobile']) ) {
			$mobile = str_replace(array(' ', '-', ' /', '.'), '', trim($_POST['mobile']));
			$parsed = $this->parsePhoneNumber($mobile, 'M');
			if ($parsed == false) {
				echo 'error^mobile'; exit;
			}
			$mobile = implode('-', $parsed);
			if ($mobile === false) {
				echo 'error^mobile'; exit;
			}
		}	else {
			//echo 'empty^mobile'; exit;
			$mobile = '';
		}

		//팩스번화번호
		if ( isset($_POST['fax']) && !empty($_POST['fax']) ) {
			$fax    = str_replace(array(' ', '-', ' /', '.'), '', trim($_POST['fax']));
			$parsed = $this->parsePhoneNumber($fax, 'P');
			if ($parsed == false) {
				echo 'error^fax'; exit;
			}
			$fax = implode('-', $parsed);
			if ($mobile === false) {
				echo 'error^fax'; exit;
			}
		}	else {
			//echo 'empty^fax'; exit;
			$fax = '';
		}

		//이메일 주소
		if ( isset($_POST['email']) && !empty($_POST['email']) ) {
			$email = sanitize_email(trim($_POST['email']));
			if (!filter_var($email, FILTER_VALIDATE_EMAIL)) { echo 'error^email'; exit;}
		} else {
			//echo 'empty^email'; exit;
			$email = '';
		}

		//태그
		if ( isset($_POST['tag']) && !empty($_POST['tag']) ) {
			$tag = sanitize_text_field(trim($_POST['tag']));
		} else {
			//echo 'empty^tag'; exit;
			$tag = '';
		}

		//메모
		if ( isset($_POST['memo']) && !empty($_POST['memo']) ) {
			$memo = trim($_POST['memo']);
		} else {
			echo 'empty^memo'; exit;
		}

		//데이터 준비
		$dataSet = array(
			'hide'         => $hide,
			'category'     => $category,
			'branchname'   => sanitize_text_field($branchname),
			'addresstype'  => $addresstype,
			'languagetype' => $languagetype,
			'zipcode'      => $zipcode,
			'address1'     => $address1,
			'address2'     => sanitize_text_field($address2),
			'mapaddress'   => $mapaddress,
			'sido'         => $sido,
			'sigungu'      => $sigungu,
			'bname'        => $bname,
			'phone'        => sanitize_text_field($phone),
			'mobile'       => sanitize_text_field($mobile),
			'fax'          => sanitize_text_field($fax),
			'email'        => sanitize_email($email),
			'tag'          => sanitize_text_field($tag),
			'memo'         => $memo,
		);

		if ($_POST['mode'] === 'add') {
			$dataSet['prefix']  = $wpdb->prefix;
			$dataSet['regdate'] = time();
			// DO INSERT
			$prepare = $wpdb->insert(
				$this->table_list,
				$dataSet,
				array('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')
			);
		}

		if ($_POST['mode'] === 'edit') {
			// DO UPDATE
			$prepare = $wpdb->update(
				$this->table_list,
				$dataSet,
				array( 'uid' => $_POST['uid'] )
			);
		}
	}

	// 지점 목록관리
	public function branch_bulkmanage() {
		global $wpdb;
		if ($_POST['mode'] == 'toggle') {
			foreach($_POST['uid'] as $k => $v) {
				$hide = $_POST['hide'][$k] == 'N' ? 'Y' : 'N';
				$wpdb->update(
					$this->table_list,
					array('hide' => $hide),
					array('uid' => $v)
				);
			}
		}

		if ($_POST['mode'] == 'delete') {
			foreach($_POST['uid'] as $k => $v) {
				$wpdb->delete(
					$this->table_list,
					array('uid' => $v)
				);
			}
		}

	}

	// 데이터 백업
	public function data_backup() {
		require_once BBSE_FRANCHISE_PLUGIN_ABS_PATH.'lib/databackup.class.php';
		$data_backup = new FRANCHISEdataBACKUP();
		$tbls        = $data_backup->get_tables();
		$xml_data    = NULL;
		foreach($tbls as $key => $value){
			$xml_data .= $data_backup->get_xml($value);
		}
		$data_backup->xml_download($xml_data);
	}

	// 데이터 복원
	public function data_restore() {
		require_once BBSE_FRANCHISE_PLUGIN_ABS_PATH.'lib/databackup.class.php';
		$data_backup = new FRANCHISEdataBACKUP();
		$upload_dir  = wp_upload_dir();
		if (!empty($upload_dir['error']) || strpos($upload_dir['error'], 'writable by the server?')){
			echo 'error permission|||'.$upload_dir['path'];
			exit;
		} else {
			$xml_file = $upload_dir['basedir'].'/'.basename($_FILES['bbse_franchise_xml_file']['name']);

			if(move_uploaded_file($_FILES['bbse_franchise_xml_file']['tmp_name'], $xml_file)){
				$file_ext = explode(".", $xml_file);
				if(end($file_ext) == "xml"){
					$data_backup->xml_import($xml_file);
					echo "success";
				}else{
					echo "error file_type";
				}
				unlink($xml_file);
				exit;
			}else{
				echo "fail";
				exit;
			}
		}
	}

	//테이블 확인/삭제
	public function delete_tables() {
		if ($_POST['ehera'] == home_url()) {
			echo $this->_delete_tables();
			exit;
		} else {
			echo 'noauth';
			exit;
		}
		return;
	}

	/**************/
	/* User level */
	/**************/
	// display list & detail
	public function franchise_shortcode() {
		global $wpdb;
		if ( !$this->template ) {
			echo "ERROR";
		}

		$template     = $this->templatesCheck(BBSE_FRANCHISE_TEMPLATES_PATH, $this->template);
		$templatePath = BBSE_FRANCHISE_TEMPLATES_PATH.$template;

		wp_enqueue_style('franchise-skin', BBSE_FRANCHISE_TEMPLATES_URL.$template.'/style.css', array(), BBSE_FRANCHISE_VER, 'all' );

		$uid         = ( isset($_GET['uid'])      && !empty($_GET['uid']) )      ? $_GET['uid']                           : false;
		$sido        = ( isset($_GET['sido'])     && !empty($_GET['sido']) )     ? sanitize_text_field($_GET['sido'])     : false;
		$category    = ( isset($_GET['category']) && !empty($_GET['category']) ) ? sanitize_text_field($_GET['category']) : false;
		$keyword     = ( isset($_GET['keyword'])  && !empty($_GET['keyword']) )  ? sanitize_text_field($_GET['keyword'])  : false;

		//목록
		if ($uid == false) {
			$escaped        = array();
			$searchQueryArr = array();
			$searchQuery    = '';

			$paged          = (get_query_var('paged')) ? get_query_var('paged') : 1;
			$perpage        = $this->perpage ? $this->perpage : get_option('posts_per_page');
			$pagingQuery    = ' LIMIT '.(($paged - 1) * $perpage).', '.$perpage.' ';

			$prepare = "";
			$prepare = " {$this->table_list} WHERE ( prefix='{$wpdb->prefix}' AND hide='N' ) ";

			if ($this->usemapnavi == 'y' && $sido) {
				$searchQueryArr[] = ' ( sido = \''.$sido.'\' ) ';
			}

			if ($category) {
				$searchQueryArr[] = ' ( category = \''.$category.'\' ) ';
			}

			if ($keyword) {
				$keyword     = '%'.$keyword.'%';
				if ($this->usemapnavi == 'y' && $sido == false)	{
					$escaped[] = $wpdb->prepare(" sido LIKE '%s' ",       $keyword);
				}
				if ($category == false)	{
					$escaped[] = $wpdb->prepare(" category LIKE '%s' ",   $keyword);
				}
				$escaped[] = $wpdb->prepare(" branchname LIKE '%s' ", $keyword);
				$escaped[] = $wpdb->prepare(" address2 LIKE '%s' ",   $keyword);
				if ($this->usemapnavi == 'y') {
					$escaped[] = $wpdb->prepare(" address1 LIKE '%s' ", $keyword);
					$escaped[] = $wpdb->prepare(" sigungu LIKE '%s' ",  $keyword);
					$escaped[] = $wpdb->prepare(" bname LIKE '%s' ",    $keyword);
				}
				$escaped[] = $wpdb->prepare(" phone LIKE '%s' ",      $keyword);
				$escaped[] = $wpdb->prepare(" mobile LIKE '%s' ",     $keyword);
				$escaped[] = $wpdb->prepare(" fax LIKE '%s' ",        $keyword);
				$escaped[] = $wpdb->prepare(" email LIKE '%s' ",      $keyword);
				$escaped[] = $wpdb->prepare(" tag LIKE '%s' ",        $keyword);

				$searchQueryArr[] = ' ( '.implode(' OR ', $escaped).' ) ';
			}
			if ( ($sido || $keyword || $category) && !empty($searchQueryArr) ) {
				$searchQuery = ' AND '.implode(' AND ', $searchQueryArr);
			}

			// DO SELECT
			$DATA  = $wpdb->get_results( " SELECT * FROM ".$prepare.$searchQuery.' ORDER BY uid DESC '.$pagingQuery );
			$total = $wpdb->get_var( " SELECT count(*) FROM ".$prepare.$searchQuery );

			$used_categories_R = $wpdb->get_results( " SELECT category FROM {$this->table_list} WHERE ( prefix='{$wpdb->prefix}' AND hide='N' ) GROUP BY category" );

			if ($used_categories_R) {
				foreach($used_categories_R as $k=>$v) {
					if ($v->category != '') {
						$used_categories[] = $v->category;
					}
				}
			}

			//페이징
			$link       = html_entity_decode(get_pagenum_link());
			$query_args = array();
			$urlQuery   = explode( '?', $link );
			if ( isset( $urlQuery[1] ) ) {
				wp_parse_str( $urlQuery[1], $query_args );
			}
			$pages      = ceil($total/$perpage);
			$base       = trailingslashit(remove_query_arg(array_keys($query_args),$link)).'%_%';

			$format     = $GLOBALS['wp_rewrite']->using_index_permalinks() && ! strpos( $base, 'index.php' ) ? 'index.php/' : '';
			$format    .= $GLOBALS['wp_rewrite']->using_permalinks() ? user_trailingslashit( 'page/%#%', 'paged' ) : '?paged=%#%';

			$paging = paginate_links( array(
				'current'   => $paged,
				'base'      => $base,
				'total'     => $pages,
				'format'    => $format,
				'mid_size'  => 5,
				'add_args'  => array_map( 'urlencode', $query_args ),
				'prev_next' => true,
				'prev_text' => '&lt;',
				'next_text' => '&gt;',
			) );
			require_once($templatePath.'/list.php');
		//보기
		} else {
			$DATA  = $wpdb->get_row( "SELECT * FROM {$this->table_list} WHERE ( prefix='{$wpdb->prefix}' AND hide='N' ) AND uid = {$uid}" );
			$titleArray = array(
				'K' => array(
					'th1'     => '지점명',
					'th2'     => '주소',
					'th3'     => '연락처',
					'th4'     => '비고',
					'address' => $DATA->address1." ".sanitize_text_field(stripslashes($DATA->address2)),
					'phone'   => '일반전화 : ',
					'mobile'  => '휴대전화 : ',
					'fax'     => '팩스 : ',
					'email'   => '이메일 : ',
				),
				'E' => array(
					'th1'     => 'Branch name',
					'th2'     => 'Address',
					'th3'     => 'Contacts',
					'th4'     => 'ETC.',
					'address' => sanitize_text_field(stripslashes($DATA->address2)).", ".$DATA->address1,
					'phone'   => 'Phone : ',
					'mobile'  => 'Mobile : ',
					'fax'     => 'FAX. : ',
					'email'   => 'eMail : ',
				),
			);

			$DATA->title = $titleArray[$DATA->languagetype];
			if ($DATA) {
				require_once($templatePath.'/view.php');
			} else {
				return false;
			}
		}
	}

/***************************************************/
/*
		FUNCTIONS
*/
/***************************************************/
	//configs
	public function configs() {
		$config = array();
		$config['pageid']         = $this->pageid;
		$config['listtitle']      = $this->listtitle;
		$config['listcomment']    = $this->listcomment;
		$config['usemapnavi']     = $this->usemapnavi;
		$config['template']       = $this->template;
		$config['category']       = $this->category;
		$config['perpage']        = $this->perpage;
		$config['useapi']         = $this->useapi;
		$config['naverapiid']     = $this->naverapiid;
		$config['naverapisecret'] = $this->naverapisecret;
		$config['daumapikey']     = $this->daumapikey;

		$config['table_config']   = $this->table_config;
		$config['table_list']     = $this->table_list;
		$config['table_category'] = $this->table_category;

		return $config;
	}

	//템플릿 목록
	public function templates() {
		$dirHandle = NULL;
		$templatesList  = array();
		if ( is_dir(BBSE_FRANCHISE_TEMPLATES_PATH) ) {
			$dirInfo = scandir(BBSE_FRANCHISE_TEMPLATES_PATH);
			foreach($dirInfo as $v) {
				if ($v != '.' && $v != '..' && filetype(BBSE_FRANCHISE_TEMPLATES_PATH.$v) == 'dir') {
					$templatesList[] = $v;
				}
			}
		}
		return $templatesList;
	}

	//템플릿 체크
	public function templatesCheck($path, $templates) {
		if ( is_dir($path.$templates) ) {
			if ( is_file($path.$templates.'/list.php') && is_file($path.'/'.$templates.'/view.php') && is_file($path.'/'.$templates.'/style.css') ) {
				return $templates;
			} else {
				return 'default';
			}
		} else {
			return 'default';
		}
	}

	//전화번호 확인
	public function parsePhoneNumber($number, $type='M') {
		$patterns = array('P'=> '/(02|031|032|033|041|042|043|044|051|052|053|054|055|061|062|063|064|070)(\d{3,4})(\d{4})/',
											'M'=> '/(010|011|015|016|017|018|019)(\d{3,4})(\d{4})/');

		//대표번호 - 일반번호중 대표번호 사용하는 사업장이 있을 가능성이 많아 추가, 기타 특수 번호는 잘못된 번호로 밴.
		$patternE = '/(1666|1688|1544|1644|1661|1599|1566|1600|1670|1588|1877)(\d{4})/';
		$number   = trim(str_replace(array(' ', '-', '.'), '', $number));
		if (is_numeric($number)) {
			preg_match_all($patterns[$type], $number, $out, PREG_SET_ORDER);
			if ( isset($out) && !empty($out) ) {
				$result[0] = $out[0][1];
				$result[1] = $out[0][2];
				$result[2] = $out[0][3];
				return $result;
			} else {
				if ($type == 'P') {
					preg_match_all($patternE, $number, $out, PREG_SET_ORDER);
					if ( isset($out) && !empty($out) ) {
						$result[0] = $out[0][1];
						$result[1] = $out[0][2];
						return $result;
					} else {
						return false;
					}
				}else{
					return false;
				}
			}
		} else {
			return false;
		}
	}

	//네이버 좌표 엳기
	//네이버맵
	// 주소 좌표 가져오기
	public function get_navermap_geocode($p_str_addr="", $showerror) {
		global $theme_shortname, $wp_version;

		$openC  = '<!-- ';
		$closeC = ' -->';
		if ($showerror == 'y') {
			$openC  = '';
			$closeC = '';
		}

		$str_addr   = str_replace(' ', '', $p_str_addr);

		$dest_url   = "https://openapi.naver.com/v1/map/geocode?encoding=utf-8&coord=latlng&output=json&query=".urlencode($str_addr);
		$args = array(
				'Accept'     => '*/*',
				'Host'       => 'penapi.naver.com',
				'user-agent' => 'WordPress/' . $wp_version. '; ' . get_bloginfo( 'url' ),
				'headers'    => array(
														'Content-Type'          => 'application/json',
														'X-Naver-Client-Id'     => $this->naverapiid,
														'X-Naver-Client-Secret' => $this->naverapisecret,
													),
		);

		$str_result = wp_remote_get( $dest_url, $args);
		$str_body   = wp_remote_retrieve_body($str_result);
		$obj_json   = json_decode($str_body)->result->items[0];
		return array($obj_json->point->x, $obj_json->point->y);

	}

	// 네이버맵을 그립니다. MapAPI 2.0 (2016/02 newer api)
	public	function draw_naver_map($vars=array()) {
		global $theme_shortname;

		//기본값 설정
		if ( empty($vars['showerror']) ) $vars['showerror'] = 'n';
		if ( empty($vars['level']) )	   $vars['level']     = '12';
		if ( empty($vars['width']) )	   $vars['width']     = '100%';
		if ( empty($vars['height']) )    $vars['height']    = '40vh';

		if ( $vars['showerror'] == 'y' ) {
			$vars['openC']  = '';
			$vars['closeC'] = '';
		}else{
			$vars['openC'] = '<!-- ';
			$vars['closeC'] = ' -->';
		}

		if ( !$this->naverapiid || !$this->naverapisecret ) {
			echo $vars['openC'].'네이버지도 오류 : API 설정안됨<br>'.$vars['closeC'];
			return false;
		}

		//주소확인
		if ($vars['address']) {
			$str_addr = $vars['address'];
		} else {
			echo $vars['openC'].'네이버지도 오류 : 주소 설정안됨<br>'.$vars['closeC'];
			return false;
		}

		//좌표확인
		$geocodex = false;
		$geocodey = false;

		list($geocodex, $geocodey) = $this->get_navermap_geocode( $str_addr, $vars['showerror'] );
		if ($geocodex == false || $geocodey == false) {
			echo $vars['openC'].'네이버지도 오류 : 주소변환 오류<br>'.$vars['closeC'];
			return false;
		}

		list($usec, $sec) = explode(" ", microtime());
		$uID = ($usec+$usec)*1000000;

		//지도 마크업 생성
		$mapHtml  = '';
		$mapHtml .= '<!-- 네이버지도 시작 -->';
		$mapHtml .= '<div class="naverMapWrap'.$uID.'">'.PHP_EOL;
		$mapHtml .= '	<div id="naver-map'.$uID.'" style="width:'.$vars['width'].';height:'.$vars['height'].'"></div>'.PHP_EOL;
		$mapHtml .= '<script type="text/javascript" src="http://openapi.map.naver.com/openapi/v2/maps.js?clientId='.$this->naverapiid.'"></script>'.PHP_EOL;

		//지도스크립트
		$mapHtml .= '<script>'.PHP_EOL;
		$mapHtml .= '  var oPoint = new nhn.api.map.LatLng('.$geocodey.', '.$geocodex.');'.PHP_EOL;
		$mapHtml .= '  nhn.api.map.setDefaultPoint(\'LatLng\');'.PHP_EOL;
		$mapHtml .= '  var markerCount = 0;'.PHP_EOL;
		$mapHtml .= '  oMap = new nhn.api.map.Map(\'naver-map'.$uID.'\', {'.PHP_EOL;
		$mapHtml .= '    point              : oPoint,'.PHP_EOL;
		$mapHtml .= '    zoom               : '.$vars['level'].','.PHP_EOL;
		$mapHtml .= '    enableWheelZoom    : true,'.PHP_EOL;
		$mapHtml .= '    enableDragPan      : true,'.PHP_EOL;
		$mapHtml .= '    enableDblClickZoom : false,'.PHP_EOL;
		$mapHtml .= '    mapMode            : 0,'.PHP_EOL;
		$mapHtml .= '    activateTrafficMap : false,'.PHP_EOL;
		$mapHtml .= '    activateBicycleMap : false,'.PHP_EOL;
		$mapHtml .= '    minMaxLevel        : [ 1, 14 ]'.PHP_EOL;
		$mapHtml .= '  });'.PHP_EOL;
		if ( empty($useDirect) ||  $useDirect == false ) {
		$mapHtml .= '  mapTypeChangeButton = new nhn.api.map.MapTypeBtn();'.PHP_EOL;
		$mapHtml .= '  var mapZoom         = new nhn.api.map.ZoomControl();'.PHP_EOL;
		$mapHtml .= '  mapZoom.setPosition({left:10, top:10});'.PHP_EOL;
		$mapHtml .= '  oMap.addControl(mapZoom);'.PHP_EOL;
		$mapHtml .= '  mapTypeChangeButton.setPosition({top:10, left:50});'.PHP_EOL;
		$mapHtml .= '  oMap.addControl(mapTypeChangeButton);'.PHP_EOL;
		}
		$mapHtml .= '  var oSize   = new nhn.api.map.Size(28, 37);'.PHP_EOL;
		$mapHtml .= '  var oOffset = new nhn.api.map.Size(14, 37);'.PHP_EOL;
		$mapHtml .= '  var oIcon   = new nhn.api.map.Icon(\'http://static.naver.com/maps2/icons/pin_spot2.png\', oSize, oOffset);'.PHP_EOL;
		$mapHtml .= '  var oMarker = new nhn.api.map.Marker(oIcon, { title : \''.$vars['branchname'].'\' });'.PHP_EOL;
		$mapHtml .= '  oMarker.setPoint(oPoint);'.PHP_EOL;
		$mapHtml .= '  oMap.addOverlay(oMarker);'.PHP_EOL;

		/*$mapHtml .= '  var oLabel = new nhn.api.map.MarkerLabel();'.PHP_EOL;
		$mapHtml .= '  oMap.addOverlay(oLabel);'.PHP_EOL;
		$mapHtml .= '  oLabel.setVisible(true, oMarker); // 마커 라벨 보이기'.PHP_EOL;*/

		$mapHtml .= '</script>'.PHP_EOL;
		$mapHtml .= '</div>';
		$mapHtml .= '<!-- //네이버지도 마침 -->';

		//출력
		echo $mapHtml;
		unset($mapHtml);
		return false;
	}

	//다음지도
	public function draw_daum_map($vars=array()) {

		//기본값확인/설정
		if ( empty($vars['showerror']) ) $vars['showerror'] = 'n';
		if ( empty($vars['level']) )	   $vars['level']     = '3';
		if ( empty($vars['width']) )	   $vars['width']     = '100%';
		if ( empty($vars['height']) )    $vars['height']    = '40vh';

		if ( $vars['showerror'] == 'y' ) {
			$vars['openC']  = '';
			$vars['closeC'] = '';
		}else{
			$vars['openC'] = '<!-- ';
			$vars['closeC'] = ' -->';
		}

		//API 키 확인
		if ($this->daumapikey) {
			$map_key = $this->daumapikey;
		} else {
			echo $vars['openC'].'다음지도 오류 : API 설정안됨<br>'.$vars['closeC'];
			return false;
		}

		//주소확인
		if ($vars['address']) {
			$str_addr = $vars['address'];
		} else {
			echo $vars['openC'].'다음지도 오류 : 주소 설정안됨<br>'.$vars['closeC'];
			return false;
		}

		//마커내용
		$marker  = false;
		$marker .= '<div style="padding:3px 5px 5px;line-height:inherit;text-align:center;font-weight:bold;font-size:12px;box-sizing:border-box">';
		$marker .= $vars['branchname'];
		$marker .= '</div><br>';
		list($usec, $sec) = explode(" ", microtime());
		$uID = ($usec+$usec)*1000000;

		//지도 마크업 생성
		$mapHtml  = '';
		$mapHtml .= '<!-- 다음지도 시작 -->'.PHP_EOL;
		$mapHtml .= '<div class="daumMapWrap'.$uID.'">'.PHP_EOL;
		if ( empty($useDirect) || $useDirect == false) {
		$mapHtml .= '	<style scoped>'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' {position:relative;overflow:hidden;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .radius_border{border:1px solid #919191;border-radius:5px;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_typecontrol {position:absolute;top:10px;right:10px;overflow:hidden;width:132px;height:30px;margin:0;padding:0;z-index:3;font-size:12px;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_typecontrol span {display:block;width:65px;height:30px;line-height:30px !important;float:left;text-align:center;line-height:30px;cursor:pointer;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_typecontrol .btn {background:#fff;background:linear-gradient(#fff,  #e6e6e6);}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_typecontrol .btn:hover {background:#f5f5f5;background:linear-gradient(#f5f5f5,#e3e3e3);}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_typecontrol .btn:active {background:#e6e6e6;background:linear-gradient(#e6e6e6, #fff);}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_typecontrol .selected_btn {color:#fff !important;background:#425470;background:linear-gradient(#425470, #5b6d8a);}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_typecontrol .selected_btn:hover {color:#fff;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_zoomcontrol {position:absolute;top:50px;right:10px;width:36px;height:80px;overflow:hidden;z-index:3;background-color:#f5f5f5;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_zoomcontrol span {display:block;width:36px;height:40px;text-align:center;cursor:pointer;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_zoomcontrol span img {width:15px;padding:12px 0;border:none;}'.PHP_EOL;
		$mapHtml .= '		.daumMapWrap'.$uID.' .custom_zoomcontrol span:first-child{border-bottom:1px solid #bfbfbf;}'.PHP_EOL;
		$mapHtml .= '	</style>'.PHP_EOL;
		$mapHtml .= '	<div class="custom_typecontrol radius_border">'.PHP_EOL;
		$mapHtml .= '		<span id="btnRoadmap" class="toggleType selected_btn" data-maptype="roadmap">지도</span>'.PHP_EOL;
		$mapHtml .= '		<span id="btnSkyview" class="toggleType btn" data-maptype="skyview">스카이뷰</span>'.PHP_EOL;
		$mapHtml .= '	</div>'.PHP_EOL;
		$mapHtml .= '	<div class="custom_zoomcontrol radius_border"> '.PHP_EOL;
		$mapHtml .= '		<span class="zoomIn"><img src="http://i1.daumcdn.net/localimg/localimages/07/mapapidoc/ico_plus.png" alt="확대"></span> '.PHP_EOL;
		$mapHtml .= '		<span class="zoomOut"><img src="http://i1.daumcdn.net/localimg/localimages/07/mapapidoc/ico_minus.png" alt="축소"></span>'.PHP_EOL;
		$mapHtml .= '	</div>'.PHP_EOL;
		}
		$mapHtml .= '	<div id="daum-map'.$uID.'" style="'.$vars['width'].';height:'.$vars['height'].'"></div>'.PHP_EOL;
		$mapHtml .= '	<script src="//apis.daum.net/maps/maps3.js?apikey='.$map_key.'&libraries=services"></script>'.PHP_EOL;
		$mapHtml .= '	<script>'.PHP_EOL;
		$mapHtml .= '	var geocoder = new daum.maps.services.Geocoder();'.PHP_EOL;
		$mapHtml .= '	geocoder.addr2coord(\''.$str_addr.'\', function(status, result) {'.PHP_EOL;
		$mapHtml .= '		if (status === daum.maps.services.Status.OK) {'.PHP_EOL;
		$mapHtml .= '			var mapContainer = document.getElementById(\'daum-map'.$uID.'\');'.PHP_EOL;
		$mapHtml .= '			var coords       = new daum.maps.LatLng(result.addr[0].lat, result.addr[0].lng);'.PHP_EOL;
		$mapHtml .= '			var mapOption = {'.PHP_EOL;
		$mapHtml .= '				center: new daum.maps.LatLng(result.addr[0].lat, result.addr[0].lng),'.PHP_EOL;
		$mapHtml .= '				level: '.$vars['level'].''.PHP_EOL;
		$mapHtml .= '			};'.PHP_EOL;
		$mapHtml .= '			var map    = new daum.maps.Map(mapContainer, mapOption);'.PHP_EOL;
		$mapHtml .= '			var marker = new daum.maps.Marker({'.PHP_EOL;
		$mapHtml .= '				map: map,'.PHP_EOL;
		$mapHtml .= '				position: coords'.PHP_EOL;
		$mapHtml .= '			});'.PHP_EOL;

		if ( empty($useDirect) || $useDirect == false) {
		$mapHtml .= '			jQuery(\'.toggleType\').on(\'click\', function() {'.PHP_EOL;
		$mapHtml .= '				var roadmapControl = jQuery(\'#btnRoadmap\');'.PHP_EOL;
		$mapHtml .= '				var skyviewControl = jQuery(\'#btnSkyview\');'.PHP_EOL;
		$mapHtml .= '				var $maptype = jQuery(this).data(\'maptype\');'.PHP_EOL;
		$mapHtml .= '				if ($maptype === \'roadmap\') {'.PHP_EOL;
		$mapHtml .= '					map.setMapTypeId(daum.maps.MapTypeId.ROADMAP);    '.PHP_EOL;
		$mapHtml .= '					roadmapControl.removeClass(\'btn\').addClass(\'selected_btn\');'.PHP_EOL;
		$mapHtml .= '					skyviewControl.removeClass(\'selected_btn\').addClass(\'btn\');'.PHP_EOL;
		$mapHtml .= '					jQuery(\'.custom_typecontrol\').data(\'type\');'.PHP_EOL;
		$mapHtml .= '				} else {'.PHP_EOL;
		$mapHtml .= '					map.setMapTypeId(daum.maps.MapTypeId.HYBRID);    '.PHP_EOL;
		$mapHtml .= '					roadmapControl.removeClass(\'selected_btn\').addClass(\'btn\');'.PHP_EOL;
		$mapHtml .= '					skyviewControl.removeClass(\'btn\').addClass(\'selected_btn\');'.PHP_EOL;
		$mapHtml .= '				}'.PHP_EOL;
		$mapHtml .= '			});'.PHP_EOL;
		$mapHtml .= '			jQuery(\'.zoomIn\').on(\'click\', function() {'.PHP_EOL;
		$mapHtml .= '				map.setLevel(map.getLevel() - 1);'.PHP_EOL;
		$mapHtml .= '			});'.PHP_EOL;
		$mapHtml .= '			jQuery(\'.zoomOut\').on(\'click\', function() {'.PHP_EOL;
		$mapHtml .= '				 map.setLevel(map.getLevel() + 1);'.PHP_EOL;
		$mapHtml .= '			});'.PHP_EOL;
		}
		if ( $vars['showerror'] == 'y' ) {
		$mapHtml .= '		} else {'.PHP_EOL;
		$mapHtml .= '			alert(\'다음지도 오류 : 주소변환 오류.\');'.PHP_EOL;
		}
		$mapHtml .= '		}'.PHP_EOL;
		$mapHtml .= '	});'.PHP_EOL;
		$mapHtml .= '	</script>'.PHP_EOL;
		$mapHtml .= '</div>'.PHP_EOL;

		//출력
		echo $mapHtml;
		unset($mapHtml);
		return false;
	}

	//where is shortcode?
	public function where_page() {
		global $wpdb;

		$sCode  = 'bbse_franchise';
		$FINAL  = array();

		$query  = ' SELECT ID, post_content, post_title';
		$query .= ' FROM  `'.$wpdb->prefix.'posts` ';
		$query .= " WHERE `post_content` LIKE '%".$sCode."%' AND `post_status` = 'publish' AND `post_type` = 'page' ";
		$result = $wpdb->get_row($query);
		wp_reset_query();

		if ($result->ID && $result->post_content) {
			$M = array();
			$output = preg_match_all('/'.$sCode.'/i', $result->post_content, $M);
			if (isset($M) && $M[0][0] == $sCode) {
				$FINAL = $result;
			}
		}

		return $FINAL;
	}

	public function find_page() {
		global $wpdb;

		$sCode  = 'bbse_franchise';
		$FINAL  = array();

		$query  = ' SELECT ID, post_content, post_title';
		$query .= ' FROM  `'.$wpdb->prefix.'posts` ';
		$query .= " WHERE `post_content` LIKE '%".$sCode."%' AND `post_status` = 'publish' AND `post_type` = 'page' ";
		$result = $wpdb->get_results($query);
		wp_reset_query();

		if ($result) {
			foreach($result as $k=>$v) {
				$M = array();
				$output = preg_match_all('/'.$sCode.'/i', $v->post_content, $M);
				if (isset($M) && $M[0][0] == $sCode) {
					$FINAL[$k]['post_title'] = $v->post_title;
					$FINAL[$k]['ID']         = $v->ID;
				}
			}
		}
		if (!empty($FINAL)) {
			return $FINAL;
		} else {
			return array();
		}
	}
}